####################################################################
#                                                                  #
#                 Estimacin de la densidad                        #
#                                                                  #
####################################################################

data.frame(airquality)
names(airquality)
airquality$Ozone
airquality$Temp


######################################################################
#                       Ncleo gausiano                              #
######################################################################
gausiano<-function(x){

    sol<-(2*pi)^(-1/2)*exp(-(x^2)/2)
    return<-sol    

}


nucleoGausiano<-function(x,muestra,h){
    nx=length(x)
    fx=numeric(nx)
    
    for (i in 1:nx){
    nucleo<-mean(gausiano((muestra-x[i])/h))
    fx[i]=nucleo/h
    }
    
    return(fx)
}



######################################################################
#                       Validacin cruzada                           #
######################################################################

int<-function(x,fx){ 
    delta=x[2]-x[1]
    n=length(x)
    integral=sum(fx)*delta-fx[1]*delta/2-fx[n]*delta/2
    return(integral)
}         
       

LCSV<-function(x,muestra,h){   
    nx=length(x)
    for(i in 1:nx){         
    ind<-c(1:nx)
    j<-which(ind!=i)  
    suma<-sum(x[i]-x[j]/h)
    nucleo<-mean(gausiano((muestra-x[j])/h))/(nx-1)
    x2<-2*nucleo    
}


#########################################################################
#   Modelos de prueba. 15 densidades descritas en Marron y Wand (1992)  #
#########################################################################
library(nor1mix)
n<-100 
B=500
x <- seq(-4,5, length=n)

Z1<-matrix(0,B,n)
Z2<-matrix(0,B,n)
Z3<-matrix(0,B,n)
Z4<-matrix(0,B,n)
Z5<-matrix(0,B,n)
Z6<-matrix(0,B,n)
Z7<-matrix(0,B,n)
Z8<-matrix(0,B,n)
Z9<-matrix(0,B,n)
Z10<-matrix(0,B,n)
Z11<-matrix(0,B,n)
Z12<-matrix(0,B,n)
Z13<-matrix(0,B,n)
Z14<-matrix(0,B,n)
Z15<-matrix(0,B,n)


for (b in 1:B){
Z1[b,]<-dnorMix(x,MW.nm1)
Z2[b,]<-dnorMix(x,MW.nm2)
Z3[b,]<-dnorMix(x,MW.nm3)
Z4[b,]<-dnorMix(x,MW.nm4)
Z5[b,]<-dnorMix(x,MW.nm5)
Z6[b,]<-dnorMix(x,MW.nm6)
Z7[b,]<-dnorMix(x,MW.nm7)
Z8[b,]<-dnorMix(x,MW.nm8)
Z9[b,]<-dnorMix(x,MW.nm9)
Z10[b,]<-dnorMix(x,MW.nm10)
Z11[b,]<-dnorMix(x,MW.nm11)
Z12[b,]<-dnorMix(x,MW.nm12)
Z13[b,]<-dnorMix(x,MW.nm13)
Z14[b,]<-dnorMix(x,MW.nm14)
Z15[b,]<-dnorMix(x,MW.nm15)
}
